#include <sys/mman.h>
#include <stdio.h>
#include <errno.h>
#include <string.h>

int main(int argc, char **argv)
{
	char *ptr;
	int size;

	size = (argc > 1) ? atoi(argv[1]) : (100 * 4096);

	ptr = mmap(NULL, size, PROT_READ | PROT_WRITE,
			   MAP_SHARED | MAP_ANONYMOUS | MAP_HUGETLB, -1, 0);

	if (ptr != (void *) -1)
		printf("success: %p\n", ptr);
	else
		printf("failure: %s\n", strerror(errno));

	sleep(10);

	return 0;
}
